#include "iRRAM.h"

/*
 Test Inversion of matrices, similar to 'matrix.cc', but with
 matrices of very bad condition.
*/
void write  (const REALMATRIX& x){
  for (unsigned int i=0;i<rows(x);i++) {
    for (unsigned int j=0;j<columns(x);j++) {
      cout << x(i,j)<< " ";
      }
    cout << "\n";
    }
}

void compute(){
  REALMATRIX m,n,o;
  int size,i,j;

  rout << "Inversion of Hilbert matrix\n"
       <<"Size of matrix: ";
  rin >> size;
  rout << "\n";

  cout << setw(10);

  m=REALMATRIX(size,size);
  for (i=0;i<size;i++)
  for (j=0;j<size;j++)
    m(i,j)=1/REAL(i+j+1);
 
  o=eye(size);
 
  rout << "Matrix H:\n";
  write(m);
  rout << "\n";

  n=o/m;

  rout << "Matrix K=inv(H):\n";
  write(n);
  rout << "\n";

  REAL mn=maxnorm(n);

  rout << "Maximum norm of K: ";
  rout << mn << "\n\n";

  o=m*n;

  rout << "Matrix K*H:\n";
  write(o);
  rout << "\n";
};
