#include "iRRAM.h"
// Algebraic numbers on top of the iRRAM using BMFS bounds
//
// This implementation is non-optimal in many ways!
// It's just a proof of concept!

class ALGEBRAIC {public:
ALGEBRAIC();
ALGEBRAIC(const int& i);

ALGEBRAIC& operator = (const ALGEBRAIC& y);

friend ALGEBRAIC operator + (const ALGEBRAIC& x, const ALGEBRAIC& y);
friend ALGEBRAIC operator - (const ALGEBRAIC& x, const ALGEBRAIC& y);
friend ALGEBRAIC operator * (const ALGEBRAIC& x, const ALGEBRAIC& y);
friend ALGEBRAIC operator / (const ALGEBRAIC& x, const ALGEBRAIC& y);
friend ALGEBRAIC sqrt (const ALGEBRAIC& x);
//ALGEBRAIC root (const ALGEBRAIC& x,unsigned int k);

friend bool   zerotest (const ALGEBRAIC& x);

REAL val;
unsigned long long deg;
REAL c_u;
REAL c_l;
};

ALGEBRAIC::ALGEBRAIC(){
  val = 0; 
  deg = 1; 
  c_u = 0; 
  c_l = 1;
}

ALGEBRAIC::ALGEBRAIC(const int& i){
  val = i;      
  deg = 1; 
  c_u = abs(i); 
  c_l = 1;
}

ALGEBRAIC& ALGEBRAIC::operator = (const ALGEBRAIC& x){
  val = x.val; 
  deg = x.deg; 
  c_u = x.c_u; 
  c_l = x.c_l;
  return (*this);
}

ALGEBRAIC::ALGEBRAIC operator + (const ALGEBRAIC& x, const ALGEBRAIC& y){
  ALGEBRAIC z;
  z.val = x.val + y.val;                 
  z.deg = x.deg * y.deg;
  if (z.deg > 1000000000) z.deg= 0;
  if (z.deg == 0 ){  z.c_u=0; z.c_l=0; } else {
  z.c_u = x.c_u * y.c_l + x.c_l * y.c_u; 
  z.c_l = x.c_l * y.c_l;
  }
  if (size(z.c_u) > 500000000 || size (z.c_l) > 500000000){
     z.deg=0; z.c_u=0;z.c_l=0;
  }
  return z;
}

ALGEBRAIC::ALGEBRAIC operator - (const ALGEBRAIC& x, const ALGEBRAIC& y){
  ALGEBRAIC z;
  z.val = x.val - y.val;                 
  z.deg = x.deg * y.deg;
  if (z.deg > 1000000000) z.deg= 0;
  if (z.deg == 0 ){  z.c_u=0; z.c_l=0; } else {
  z.c_u = x.c_u * y.c_l + x.c_l * y.c_u; 
  z.c_l = x.c_l * y.c_l;
  }
  if (size(z.c_u) > 500000000 || size (z.c_l) > 500000000){
     z.deg=0; z.c_u=0;z.c_l=0;
  }
  return z;
}

ALGEBRAIC::ALGEBRAIC operator * (const ALGEBRAIC& x, const ALGEBRAIC& y){
  ALGEBRAIC z;
  z.val = x.val * y.val; 
  z.deg = x.deg * y.deg;
  if (z.deg > 1000000000) z.deg= 0;
  if (z.deg == 0 ){  z.c_u=0; z.c_l=0; } else {
    z.c_u = x.c_u * y.c_u; 
    z.c_l = x.c_l * y.c_l;
  }
  if (size(z.c_u) > 500000000 || size (z.c_l) > 500000000){
     z.deg=0; z.c_u=0;z.c_l=0;
  }
  return z;
}

ALGEBRAIC::ALGEBRAIC operator / (const ALGEBRAIC& x, const ALGEBRAIC& y){
ALGEBRAIC z;
  z.val = x.val / y.val; 
  z.deg = x.deg * y.deg;
  if (z.deg > 1000000000) z.deg= 0;
  if (z.deg == 0 ){  z.c_u=0; z.c_l=0; } else {
  z.c_u = x.c_u * y.c_l; 
  z.c_l = x.c_l * y.c_u;
  }
  if (size(z.c_u) > 500000000 || size (z.c_l) > 500000000){
     z.deg=0; z.c_u=0;z.c_l=0;
  }
  return z;
}

ALGEBRAIC::ALGEBRAIC sqrt (const ALGEBRAIC& x){
  ALGEBRAIC z;
  z.val = sqrt(x.val);
  z.deg = 2*x.deg;
  if (z.deg > 1000000000) z.deg= 0;
  if (z.deg == 0 ){  z.c_u=0; z.c_l=0; } else {
  z.c_u = sqrt(x.c_u);
  z.c_l = sqrt(x.c_l);
  }
  if (size(z.c_u) > 500000000 || size (z.c_l) > 500000000){
     z.deg=0; z.c_u=0;z.c_l=0;
  }
  return z;
}

bool  zerotest (const ALGEBRAIC& x){
  if (x.deg == 0) return abs(x.val) == 0 ;
  else {
    REAL zerobound = 1 / power( x.c_u, x.deg*x.deg-1 ) / x.c_l;
    return choose ( abs(x.val) > 0 , abs(x.val) < zerobound )  -  1 ;
  }
};

void compute (){
  int count,width;
  cout << "\nIterated functions system: x = 3.75*x*(1-x)\n";
  cout << "\nComputation with algebraic numbers!\n";
  cout << "How many values: ";
  cin  >> count;
  cout << "How many decimals: ";
  cin  >> width;
  cout << "\n";
    
  ALGEBRAIC c(375); c= c/100;
//  ALGEBRAIC x(1);   x= sqrt(x/4);
  ALGEBRAIC x(1);   x= x/2;

  for ( int i=0; i<=count; i++ ) {
    if ( (i<100) || (i%10)==0 ) {
      cout << i<< ": "<< setRwidth(width) << x.val   << " "  << x.deg       << " "
           <<  setRwidth(15)  << upperbound(x.c_u) << " "  << upperbound(x.c_l) << "\n";
    }
    if ( zerotest (x) )   cout << "Zero  for "<< i<<"\n"; 
    else   cout << "Non-Zero  for "<< i<<"\n"; 
//    if ( zerotest (x-x) ) cout << "Identity for "<< i<<"\n"; 
//    else   cout << "Non-Identity  for "<< i<<"\n"; 
    x=c*x*(1-x);
  }
}
